proc away_IM_IN {name source msg auto} {
    if { $::TAC(away) != "" } then {
        if {[lsearch $::TAC(usersfrom) [normalize $source]] == -1} {
            lappend ::TAC(usersfrom) [normalize $source]
            toc_send_im $::NSCREENNAME $source $::TAC(away) auto
            tac_im_wrapper $source $::TAC(away) 1
        }
    }
}

proc tac_cmd_away {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (.*)$} $line match cmd n]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    switch -regexp -- $n {
        ^[0-9]$ {
            set ::TAC(away) $::TAC(awaymessage,$n)
            toc_set_away $::NSCREENNAME $::TAC(away)
            tac_output "Away, using message \"$::TAC(away)\"" }
        default {
            set a "x"
            foreach j [list 0 1 2 3 4 5 6 7 8 9] {
                if {$::TAC(awaymessage,$j) == ""} { set a $j; break }
            }
            if { $a != "x" } { set ::TAC(awaymessage,$a) $n }
            set ::TAC(away) $n
            toc_set_away $::NSCREENNAME $::TAC(away)
            tac_output "Away, using message \"$::TAC(away)\"" }
    }
}

proc tac_cmd_awayfile {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (.*)$} $line match cmd file]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {![file exists $file]} {
      tac_output "File $file does not exist"
    } else {
      set f [open $file r]
      set g [read $f]
      close $f
      set ::TAC(away) $g
      tac_output "This function has not been tested yet. Use with caution"
    }
}

proc tac_cmd_awaydef {exp line} {
    if { $::TAC(awaymessage,10) == "" } {
        set a "x"
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            if {$::TAC(awaymessage,$j) != ""} { set a $j; break }
        }
        if { $a == "x" } {
            set ::TAC(away) $::TAC(awaydef)
        } else {
            set ::TAC(away) $::TAC(awaymessage,$a)
        }
    } else {
        set ::TAC(away) $::TAC(awaymessage,10)
    }
    toc_set_away $::NSCREENNAME $::TAC(away)
    tac_output "Away, using message \"$::TAC(away)\""
}

proc tac_cmd_back {exp line} {
    if { $::TAC(away) != "" } {
        set countusers [llength $::TAC(usersfrom)]
        if { $countusers == 1 } { set n "user" } else { set n "users" }
        set ::TAC(awaymessage,10) $::TAC(away)
        set ::TAC(away) ""
        toc_set_away $::NSCREENNAME
        tac_output "Welcome back."
        if {$countusers != 0} {
            tac_output "$countusers $n IMed you while you were away."
            tac_output [concat $::TAC(usersfrom)]
        }
        set ::TAC(usersfrom) {}
    } else {
        tac_output "You are not away."
    }
}

proc tac_cmd_setaway {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) +([a-zA-Z0-9]+) (.*)$} $line match cmd num message]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(awaymessage,$num) $message
    tac_output "Message \#$num set."
}

proc tac_cmd_listwho {exp line} {
    if {$::TAC(away) == ""} {
        tac_output "You are not away."
    } else {
        tac_output [concat $::TAC(usersfrom)]
    }
}

proc tac_cmd_lsaway {exp line} {
    tac_output "Away Messages"
    tac_output "---------------"
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        tac_output "Message $j: $::TAC(awaymessage,$j)"
    }
    tac_output "Last Message Used: $::TAC(awaymessage,10)"
}

proc tac_cmd_rmaway {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) +([0-9]) *$} $line match cmd num]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { $::TAC(awaymessage,$num) == "" } {
        tac_output "Message $num not defined."
    } else {
        tac_output "$::TAC(awaymessage,$num) (message \#$num) removed from list."
        set ::TAC(awaymessage,$num) ""
    }
}

tac_register_cmd 1 "a" "^/away "    tac_cmd_away           "  /away {num|msg}  post away message"
tac_register_cmd 1 "a" "^/away$"    tac_cmd_awaydef
tac_register_cmd 1 "a" "^/back$"    tac_cmd_back           "  /back            use when you get back to your computer"
tac_register_cmd 1 "a" "^/y "       tac_cmd_setaway        "  /y num message   register away message #num"
tac_register_cmd 1 "a" "^/yu$"      tac_cmd_listwho        "  /yu              list buddies who IMed you while you were away"
tac_register_cmd 1 "a" "^/ya$"      tac_cmd_lsaway         "  /ya              list away messages"
tac_register_cmd 1 "a" "^/yr "      tac_cmd_rmaway         "  /yr num          remove away message #num"
tac_register_cmd 1 "a" "^/awayfile " tac_cmd_awayfile       " /awayfile file   set away to file contents"

tac_register_cmd 2 "a" "^a:a "      tac_cmd_away           "  a:a {num|msg}    post away message"
tac_register_cmd 2 "a" "^a:a$"      tac_cmd_awaydef
tac_register_cmd 2 "a" "^a:b$"      tac_cmd_back           "  a:b              use when you get back to your computer"
tac_register_cmd 2 "a" "^a:s "      tac_cmd_setaway        "  a:s num message  set preset away message #num"
tac_register_cmd 2 "a" "^a:w$"      tac_cmd_listwho        "  a:w              list buddies who IMed you while you were away"
tac_register_cmd 2 "a" "^a:l$"      tac_cmd_lsaway         "  a:l              list away messages"
tac_register_cmd 2 "a" "^a:r "      tac_cmd_rmaway         "  a:r num          remove away message #num"
tac_register_cmd 2 "a" "^a:f "      tac_cmd_awayfile       "  a:f filename     set away to file contents"
tac_register_cmd 2 "a" "^a:h$"      tac_cmd_help

toc_register_func * IM_IN away_IM_IN

set TAC(away) ""
set TAC(awaydef) "I am away right now."
set TAC(usersfrom) {}
set TAC(awaymessage,10) ""
foreach j [list 0 1 2 3 4 5 6 7 8 9] {
    set TAC(awaymessage,$j) ""
}
