# broadcast package

# this package will allow a message to be sent to
# a number of buddies at once.  If the phone rings
# for example, you can send a 'hang on... phone's ringing'
# message, and not have to send it to each person
# you're talking to. neat, huh?

# we need to make any user who IMs you or you send an
# IM to move to the top of the list

# this is just a basic package, it doesn't work
# very well and there are a lot of features that can
# be added to it. grab the last 0.12 beta copy (0.12b5)
# found at http://users.tmok.com/~smike/old/beta, and look at
# the TODO file. it has some ideas for improving this file.

proc broadcast_IM_IN {name source msg auto} {
    set ::TAC(lastbud) $source
    if { $auto } { return }
    if {[lsearch $::TAC(broadcast,name) $source] == -1} {
        if {[lsearch $::TAC(broadcast,out) $source] != -1} {
            lappend ::TAC(broadcast,name) $source
        } else {
            lappend ::TAC(broadcast,in) $source
        }
    }
}

proc tac_broadcast_outIM {name msg auto} {
    if { $auto } { return }
    if {[lsearch $::TAC(broadcast,name) $name] == -1} {
        if {[lsearch $::TAC(broadcast,in) $name] != -1} {
            lappend ::TAC(broadcast,name) $name
        } else {
            lappend ::TAC(broadcast,out) $name
        }
    }
}

proc tac_cmd_broadcast {exp line} {
    if {![regexp -- {^([0-9]\.) (.*)$} $line match num msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set num [string range $num 0 [expr [string length $num] -2]]
    set x [llength $::TAC(broadcast,name)]
    if {$num > $x } { set num $x }
    if {$num == 0} { return }

# this part needs to be debugged...

# a user is supposed to be on the list to be sent
# a broadcast message once you have sent that user
# an IM and they have sent you one also.
# we need to find out if this is true.

#    flush stdout
    for {set i [expr $x - 1]} {$i >= [expr $x - $num]} {incr i -1} {
        set name [lindex $::TAC(broadcast,name) $i]
        toc_send_im $::NSCREENNAME $name $msg
        tac_log_outIM $name $msg 0
        tac_output "Message sent to $name"
#        flush stdout
        after 10000
    }
}

proc tac_cmd_last {exp line} {
    if {![regexp -- {^(\.) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { "$::TAC(lastbud)"=="" } {
        tac_output "No users have IMed you"
    } else {
        toc_send_im $::NSCREENNAME $::TAC(lastbud) $msg
        tac_im_wrapper $::TAC(lastbud) $msg 0
    }
}

tac_register_cmd 0 "B" "^\[0\-9\]\+\\. "  tac_cmd_broadcast \
"  num. message     send one message to multiple buddies"
tac_register_cmd 0 "B" "^\\. "        tac_cmd_last \
"  . message        send message to last user who IMed you"
toc_register_func * IM_IN broadcast_IM_IN

set TAC(lastbud) ""
set TAC(broadcast,name) [list]
set TAC(broadcast,in) [list]
set TAC(broadcast,out) [list]
