proc defbud_IM_IN {name source msg auto} {
    if { $::TAC(autobud) == 1 } then { set e 0
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            if { [normalize $::TAC(defbud,$j)] == [normalize $source] } {
                set e 1; break
            }
        }
        if {$e == 0} {
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            foreach k [list 0 1 2 3 4 5 6 7 8 9] {
                if { [normalize $::TAC(defbud,$j$k)] == [normalize $source] } {
                    set e 1; break
                }
            }
            if {$e} {break}
        } }
        if { $e == 0 } {
            foreach j [list 1 2 3 4 5 6 7 8 9 0] {
                if { $::TAC(defbud,$j) == "" } {
                    set ::TAC(defbud,$j) [normalize $source]
                    tac_output "Buddy \#$j is now $source."
                    return
                }
            }
            foreach j [list 0 1 2 3 4 5 6 7 8 9] {
                foreach k [list 0 1 2 3 4 5 6 7 8 9] {
                    if { $::TAC(defbud,$j$k) == "" } {
                        set ::TAC(defbud,$j$k) [normalize $source]
                        tac_output "Buddy \#$j$k is now $source."
                        return
                    }
                }
            }
        }

# below is executed only if there are no slots open.

# the user didn't type anything here (it's a Toc
# callback) so there's not much use confusing them
# with an error message. besides, no one's gonna fill
# up 110 slots anyway.
#
#    tac_output "All slots appear to be filled."

    }
}

proc tac_cmd_autobuddy {exp line} {
    if { $::TAC(autobud) == 0 } then {
        set ::TAC(autobud) 1
        tac_output "Autobuddy is now on."
    } else {
        set ::TAC(autobud) 0
        tac_output "Autobuddy is now off."
    }
}

proc tac_cmd_lsbuddy {exp line} {
    tac_output "Defined Buddies"
    tac_output "---------------"
    tac_output "Last Buddy: $::TAC(lastbud)"
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        if { $::TAC(defbud,$j) != "" } {
            tac_output "Preset $j: $::TAC(defbud,$j)"
        }
    }
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        foreach k [list 0 1 2 3 4 5 6 7 8 9] {
            if { $::TAC(defbud,$j$k) != "" } {
                tac_output "Preset $j$k: $::TAC(defbud,$j$k)"
            }
        }
    }
}

proc tac_cmd_rmbuddy {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9][0-9]?) *$} $line match cmd num]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { $::TAC(defbud,$num) == "" } {
        tac_output "Preset $num not defined."
    } else {
        tac_output "$::TAC(defbud,$num) (preset \#$num) removed from list."
        set ::TAC(defbud,$num) ""
    }
}

proc tac_cmd_mvbuddy {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9][0-9]?) ([0-9][0-9]?) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set tmp $::TAC(defbud,$num2)
    set ::TAC(defbud,$num2) $::TAC(defbud,$num1)
    set ::TAC(defbud,$num1) $tmp
    if { "$::TAC(defbud,$num1)"=="" } then {
        tac_output "Preset \#$num1 is undefined."
    } else {
        tac_output "Preset \#$num1 is now $::TAC(defbud,$num1)"
    }
    if { "$::TAC(defbud,$num2)"=="" } then {
        tac_output "Preset \#$num2 is undefined."
    } else {
        tac_output "Preset \#$num2 is now $::TAC(defbud,$num2)"
    }
}

proc tac_cmd_cpbuddy {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9][0-9]?) ([0-9][0-9]?) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { "$::TAC(defbud,$num1)"=="" } then {
        tac_output "Preset \#$num1 is undefined."
    } else {
        set ::TAC(defbud,$num2) $::TAC(defbud,$num1)
        tac_output "Preset \#$num2 is now $::TAC(defbud,$num2)"
    }
}

proc tac_cmd_sdefault {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9][0-9]?) +([a-zA-Z0-9]+) *$} $line match cmd num name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(defbud,$num) $name
    tac_output "Preset \#$num is now $::TAC(defbud,$num)."
}

proc tac_cmd_sdef2 {exp line} {
    if {![regexp -- {^([0-9][0-9]?=[\@\#a-zA-Z0-9]+)$} $line match arg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set num [string range $arg 0 1]
    if {[string range $num 1 1] == "=" } { set num [string range $num 0 0] }
    set name [string range $arg [expr [string length $num] + 1] end]

    if {$name == "@" || $name == "#" } {
        tac_output "$::TAC(defbud,$num) (preset \#$num) removed from list."
        set ::TAC(defbud,$num) ""
    } elseif {[regexp -- {^[\@\#]?[0-9][0-9]?$} $name]} {
        if { [string range $name 0 0] == "@" } { set name [string range $name 1 end] }
        if { [string range $name 0 0] == "#" } { set name [string range $name 1 end] }
        set ::TAC(defbud,$num) $::TAC(defbud,$name)
        tac_output "Preset \#$num is now $::TAC(defbud,$num)."
    } else {
        set ::TAC(defbud,$num) $name
        tac_output "Preset \#$num is now $::TAC(defbud,$num)."
    }
}
    
proc tac_cmd_default {exp line} {
    if {![regexp -- {^([0-9][0-9]?) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {"$::TAC(defbud,$cmd)"==""} { 
        tac_output "Preset $cmd not defined"
        return 
    }

    toc_send_im $::NSCREENNAME $::TAC(defbud,$cmd) $msg
    tac_im_wrapper $::TAC(defbud,$cmd) $msg 0
}

tac_register_cmd 0 "s" "^\[0\-9\]\[0\-9\]\? "    tac_cmd_default  "  <num> message    send message to buddy num"
tac_register_cmd 0 "s" "^\[0\-9\]\[0\-9\]\?\="   tac_cmd_sdef2    "  <num>=buddy      set buddy preset num"
tac_register_cmd 0 "s" "^\[0\-9\]\[0\-9\]\?\= "  tac_cmd_sdef2    "  <num>=@          remove buddy preset num"

tac_register_cmd 1 "s" "^/s "       tac_cmd_sdefault       "  /s num user      set buddy preset num"
tac_register_cmd 1 "s" "^/sl$"      tac_cmd_lsbuddy        "  /sl              list previously defined presets"
tac_register_cmd 1 "s" "^/sr "      tac_cmd_rmbuddy        "  /sr num          remove buddy preset num"
tac_register_cmd 1 "s" "^/sm "      tac_cmd_mvbuddy        "  /sm num1 num2    move preset num1 to slot num2"
tac_register_cmd 1 "s" "^/sc "      tac_cmd_cpbuddy        "  /sc num1 num2    copy preset num1 to slot num2"
tac_register_cmd 1 "s" "^/au$"      tac_cmd_autobuddy      "  /au              auto set buddy number on new IM (toggle)"

tac_register_cmd 2 "s" "^s:s "      tac_cmd_sdefault       "  s:s num user     set buddy preset num"
tac_register_cmd 2 "s" "^s:l$"      tac_cmd_lsbuddy        "  s:l              list previously defined buddies"
tac_register_cmd 2 "s" "^s:r "      tac_cmd_rmbuddy        "  s:r num          remove buddy num"
tac_register_cmd 2 "s" "^s:m "      tac_cmd_mvbuddy        "  s:m num1 num2    move buddy num1 to slot num2"
tac_register_cmd 2 "s" "^s:c "      tac_cmd_cpbuddy        "  s:c num1 num2    copy buddy num1 to slot num2"
tac_register_cmd 2 "s" "^s:a$"      tac_cmd_autobuddy      "  s:a              auto set buddy number on new IM (toggle)"
tac_register_cmd 2 "s" "^s:h$"      tac_cmd_help

toc_register_func * IM_IN defbud_IM_IN

foreach j [list 0 1 2 3 4 5 6 7 8 9] {
    foreach k [list 0 1 2 3 4 5 6 7 8 9] {
        set TAC(defbud,$j$k) ""
    }
    set TAC(defbud,$j) ""
}

set TAC(autobud) 0
