proc dir_DIR_STATUS {user args} {
    if {$args == 0} {
        tac_output "Update successful."
    } else {
        tac_output "Update failed."
    }
}

proc dir_GOTO_URL {name window url} {
    if {$::TAC(urlstat) != 2} { return }
    set ::TAC(urlstat) 0
    if {[lsearch [package names] http] == -1} {
        tac_output "Go to this URL: $url"
        return
    }

    if {![string match "http://*" $url]} {
        set ip [lindex [sflap::peerinfo $name] 0]
        set url "http://$ip/$url"
    }

    if {[string match "http://*" $url]} {
        set tokn [::http::geturl $url]
        upvar #0 $tokn state
        tac_output "DEBUG: this is raw html now..."
        tac_output $state(body)
    } else {
        tac_output "DEBUG: this is raw html now..."
        tac_output $state(body)
    }
}

proc tac_cmd_gdir {exp line} {
    if {![regexp -- {^([0-9a-zA-Z/:]+) ([0-9a-zA-Z]+) *$} $line match cmd name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(urlstat) 2
    toc_get_dir $::NSCREENNAME $name
}

proc tac_cmd_sdir {exp line} {
    if {![regexp -- {^([0-9a-zA-Z/:]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z]+) ([0-9a-zA-Z\@\.]+) *$} $line match cmd first mid last maiden city state country email]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }


    set info "$first\:$mid\:$last\:$maiden\:$city\:$state\:$country\:$email"
    toc_set_dir $::NSCREENNAME $info
}

toc_register_func * GOTO_URL dir_GOTO_URL
toc_register_func * DIR_STATUS dir_DIR_STATUS

tac_register_cmd 1 "d" "^/dg "       tac_cmd_gdir            "  /dg user         get directory info for user"
tac_register_cmd 1 "d" "^/ds "       tac_cmd_sdir            "  /ds first mid last maiden city st. country e-mail"

tac_register_cmd 2 "d" "^d:g "       tac_cmd_gdir            "  d:g user         get directory info for user"
tac_register_cmd 2 "d" "^d:s "       tac_cmd_sdir            "  d:s first mid last maiden city st. country e-mail"
tac_register_cmd 2 "d" "^d:h$"       tac_cmd_help
