proc yn {a} {
    if { $a == 1 } {
        return "On"
    } elseif { $a == 0 } {
        return "Off"
    } else {
        return "Unknown"
    }
}

proc log_chat_whisper {id user msg} {
    if {$::TAC(logwhat,ochat) != 1} {return}
    set fn [open $::TAC(logfile) a]
    puts $fn "[ts y] ==[userpref $id]:$user== <whisper> $msg"
    close $fn
}
    
proc log_CHAT_UPDATE_BUDDY {name id online blist} {
    if {$::TAC(logwhat,achat) != 1} {return}
    set fn [open $::TAC(logfile) a]
    foreach i $blist {
        if {$inside == "T"} {
            puts $fn "[ts y]** $i has entered chat [userpref $id]."
        } else {
            puts $fn "[ts y]** $i has left chat [userpref $id]."
        }
    }
    close $fn
}

proc log_CHAT_JOIN {name id loc} {
    if { $::TAC(logwhat,achat) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    puts $fn "[ts y] ### Joined chat room $loc (id $id) ###"
    close $fn
}

proc log_CHAT_LEFT {name id} {
    if { $::TAC(logwhat,achat) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    puts $fn "[ts y] ### Left chat room [userpref $id] ###"
    close $fn
}

proc log_CHAT_IN {name id source whisper msg} {
    if { $::TAC(logwhat,ichat) != 1 } { return }
    set whisperstr ""
    if { $whisper == "T" } { set whisperstr " (whispers) " }
    set fn [open $::TAC(logfile) a]
    puts $fn "[ts y] ==[userpref $id]:$source==$whisperstr $msg"
    close $fn
}

proc log_SIGN_ON {name version} {
    if { $::TAC(log) == 0 || $::TAC(logwhat,session) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    puts $fn "=== (($::SCREENNAME)) Log start [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
    close $fn
}

proc log_IM_IN {name source msg auto} {
    if { $::TAC(log) == 0 || $::TAC(logwhat,iim) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    set text [unHTML $msg]
    puts -nonewline $fn "[ts y] <<$source>>"
    if { $auto } { puts -nonewline $fn " *away* " }
    puts $fn " $text"
    close $fn
}

proc log_UPDATE_BUDDY {name user online evil signon idle uclass} {
    if { $::TAC(log) == 0 } { return }
    set fn [open $::TAC(logfile) a]
    if {$online == "T"} {
        if { $::TAC(logwhat,buddyin) != 1 } { return }
        puts $fn "[ts y] ** $user has signed on."
    } else {
        if { $::TAC(logwhat,buddyout) != 1 } { return }
        puts $fn "[ts y] ** $user has signed off."
    }
    close $fn
}

proc tac_log_outIM {name msg away} {
    if { $::TAC(logwhat,oim) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    puts -nonewline $fn "[ts y] (($name)) "
    if { $away } { puts -nonewline $fn "*away*  " }
    puts $fn "$msg"
    close $fn
}

proc tac_cmd_log {exp line} {
    if { $::TAC(log) == 0 } {
        set ::TAC(log) 1
        set fn [open $::TAC(logfile) a]
        if { $::TAC(logwhat,session) == 1 } {
            puts $fn "=== (($::SCREENNAME)) Log start [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
        }
        close $fn
        tac_output "Logging started."
    } else {
        set ::TAC(log) 0
        set fn [open $::TAC(logfile) a]
        if { $::TAC(logwhat,session) == 1 } {
            puts $fn "=== Log end [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
        }
        puts $fn ""
        close $fn
        tac_output "Logging stopped."
    }
}

proc tac_cmd_logfile {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (.*)$} $line match cmd filename]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(logfile) $filename
    tac_output "Log file is now $::TAC(logfile)"
}

proc tac_cmd_logwhat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) +([a-zA-Z0-9]+) +([a-zA-Z0-9]+)$} $line match cmd option tag]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { $tag != 1 && $tag != 0 } { tac_output "Value must be 1 or 0."; return }
    switch -glob -- $option {
        iim { set ::TAC(logwhat,iim) $tag }
        oim { set ::TAC(logwhat,oim) $tag }
        i*chat { set ::TAC(logwhat,ichat) $tag }
        o*chat { set ::TAC(logwhat,ochat) $tag }
        a*chat - chat*a { set ::TAC(logwhat,achat) $tag }
        sess* { set ::TAC(logwhat,session) $tag }
        b*in { set ::TAC(logwhat,buddyin) $tag }
        b*out { set ::TAC(logwhat,buddyout) $tag }
        default { tac_cmd_logwhatH 0 0 }
    }
}

proc tac_cmd_logwhatH {exp line} {
    if {$exp == "^l:h$" } { set exp "l:w" }
    if {$exp == "^l:w$" } { set exp "l:w" }
    if {$exp == "^/lw$" } { set exp "/lw" }
    if {$exp == "^/lw " } { set exp "/lw" }

    tac_output "Usage: $exp option value"
    tac_output ""
    tac_output "option must be one of:"
    tac_output " iim       Incoming IM"
    tac_output " oim       Outgoing IM"
    tac_output " ichat     Incoming Chat Messages"
    tac_output " ochat     Outgoing Chat Messages"
    tac_output " achat     Chat Announcements"
    tac_output " session   When you log on and off"
    tac_output " buddyin   When buddies log in"
    tac_output " buddyout  When buddies log out"
    tac_output ""
    tac_output "value must be 1 (on) or 0 (off)."
    tac_output ""
    tac_output "Here are the current settings:"
    tac_output "  Incoming IM   [yn $::TAC(logwhat,iim)]"
    tac_output "  Outgoing IM   [yn $::TAC(logwhat,oim)]"
    tac_output "  Incoming Chat [yn $::TAC(logwhat,ichat)]"
    tac_output "  Outgoing Chat [yn $::TAC(logwhat,ochat)]"
    tac_output "  Chat Anncm.   [yn $::TAC(logwhat,achat)]"
    tac_output "  Session       [yn $::TAC(logwhat,session)]"
    tac_output "  Buddy In      [yn $::TAC(logwhat,buddyin)]"
    tac_output "  Buddy Out     [yn $::TAC(logwhat,buddyout)]"
}

toc_register_func * IM_IN log_IM_IN
toc_register_func * UPDATE_BUDDY log_UPDATE_BUDDY
toc_register_func * SIGN_ON log_SIGN_ON
toc_register_func * CHAT_JOIN log_CHAT_JOIN
toc_register_func * CHAT_LEFT log_CHAT_LEFT
toc_register_func * CHAT_IN log_CHAT_IN

tac_register_cmd 1 "l" "^/log$"     tac_cmd_log            "  /log             toggle log on/off"
tac_register_cmd 1 "l" "^/lf "      tac_cmd_logfile        "  /lf filename     set log file name"
tac_register_cmd 1 "l" "^/lw "      tac_cmd_logwhat        "  /lw option \[1/0\] choose which options to log"
tac_register_cmd 1 "l" "^/lw$"      tac_cmd_logwhatH       "      Enter /lw with no options for further help."

tac_register_cmd 2 "l" "^l:o$"      tac_cmd_log            "  l:o              toggle log on/off"
tac_register_cmd 2 "l" "^l:f "      tac_cmd_logfile        "  l:f filename     set log file name"
tac_register_cmd 2 "l" "^l:w "      tac_cmd_logwhat        "  l:w option \[1/0\] choose which options to log"
tac_register_cmd 2 "l" "^l:w$"      tac_cmd_logwhatH       "      Enter l:w with no options for further help."
tac_register_cmd 2 "l" "^l:h$"      tac_cmd_logwhatH

set ::TAC(logfile) "~/.taclog"
set ::TAC(log) 1
set ::TAC(logwhat,iim) 1
set ::TAC(logwhat,oim) 1
set ::TAC(logwhat,ichat) 1
set ::TAC(logwhat,ochat) 1
set ::TAC(logwhat,achat) 1
set ::TAC(logwhat,session) 1
set ::TAC(logwhat,buddyin) 1
set ::TAC(logwhat,buddyout) 1
